﻿using System;
using System.IO;
using System.Windows;
using System.Windows.Markup;
using System.Windows.Resources;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

namespace WindowsPhoneLoadXAML
{
    public partial class MainPage : PhoneApplicationPage
    {
        Ellipse ellipse;

        Rectangle rectangle;

        // Constructor
        public MainPage()
        {
            InitializeComponent();

            ellipse = LoadXAMLAndGetShape<Ellipse>("/WindowsPhoneLoadXAML;component/Ellipse.xaml");

            rectangle = LoadXAMLAndGetShape<Rectangle>("/WindowsPhoneLoadXAML;component/Rectangle.xaml");
        }

        T LoadXAMLAndGetShape<T>(string url)
        {
            string xaml = string.Empty;

            StreamResourceInfo sri = Application.GetResourceStream(new Uri(url, UriKind.Relative));

            using (StreamReader sr = new StreamReader(sri.Stream))
            {
                xaml = sr.ReadToEnd();
            }

            T shape = (T)XamlReader.Load(xaml);

            return shape;
        }

        private void btnEllipse_Click(object sender, RoutedEventArgs e)
        {
            if (ContentPanel.Children.Contains(rectangle))
            {
                this.ContentPanel.Children.Remove(rectangle);
            }
            if (ellipse != null && !ContentPanel.Children.Contains(ellipse))
            {
                this.ContentPanel.Children.Add(ellipse);
            }
        }

        private void btnRectangle_Click(object sender, RoutedEventArgs e)
        {
            if (ContentPanel.Children.Contains(ellipse))
            {
                this.ContentPanel.Children.Remove(ellipse);
            }
            if (rectangle != null && !ContentPanel.Children.Contains(rectangle))
            {
                this.ContentPanel.Children.Add(rectangle);
            }
        }
    }
}